#!/bin/bash
PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:~/bin
export PATH

# Check if user is root
if [ $(id -u) != "0" ]; then
    echo "Error: You must be root to run this script, please use root to install lnmp"
    exit 1
fi
clear
echo "========================================================================="
echo "A tool to auto-compile & install Nginx+MySQL+PHP on Linux "
echo ""
echo ""
echo "The path of some dirs:"
echo "mysql dir:   /usr/local/mysql"
echo "php dir:     /usr/local/php"
echo "nginx dir:   /usr/local/nginx"
echo "web dir      /home/www"
echo ""
echo "========================================================================="
cur_dir=$(pwd)

if [ "$1" != "--help" ]; then



	domain="www.imcat.in"
	echo "Please input domain:"
	read -p "(Default domain: imcat.in):" domain
	if [ "$domain" = "" ]; then
		domain="imcat.in"
	fi
	echo "==========================="

	echo domain="$domain"

	echo "==========================="
	
	#set mysql root password

	echo "==========================="

	mysqlrootpwd="root"
	echo "Please input the root password of mysql:"
	read -p "(Default password: root):" mysqlrootpwd
	if [ "$mysqlrootpwd" = "" ]; then
		mysqlrootpwd="root"
	fi
	echo "==========================="

	echo mysqlrootpwd="$mysqlrootpwd"

	echo "==========================="
	
	get_char()
	{
	SAVEDSTTY=`stty -g`
	stty -echo
	stty cbreak
	dd if=/dev/tty bs=1 count=1 2> /dev/null
	stty -raw
	stty echo
	stty $SAVEDSTTY
	}
	echo ""
	echo "Press any key to start..."
	char=`get_char`
	
#Synchronization time
rm -rf /etc/localtime
ln -s /usr/share/zoneinfo/Asia/Shanghai /etc/localtime

yum install -y ntp
ntpdate -d cn.pool.ntp.org
date

yum -y install yum-fastestmirror
yum -y update
yum -y remove httpd mysql php
yum -y install patch make gcc gcc-c++ gcc-g77 flex bison tar
yum -y install libtool libtool-libs kernel-devel autoconf213
yum -y install libjpeg libjpeg-devel libpng libpng-devel
yum -y install freetype freetype-devel libxml2 libxml2-devel zlib zlib-devel
yum -y install file glib2 glib2-devel bzip2 diff* openldap-devel
yum -y install bzip2-devel ncurses ncurses-devel curl curl-devel e2fsprogs
yum -y install e2fsprogs-devel krb5 krb5-devel libidn libidn-devel
yum -y install openssl openssl-devel vim-minimal sendmail unzip mutt vixie-cron
yum -y install fonts-chinese scim-chewing scim-pinyin scim-tables-chinese


if [[ `file /bin/ls` == *"64-bit"* ]]; then
cd $cur_dir
wget -c http://imcat.in/down/web/libunwind/libunwind-0.99-alpha.tar.gz
tar zxvf libunwind-0.99-alpha.tar.gz
cd libunwind-0.99-alpha/
CFLAGS=-fPIC ./configure
make CFLAGS=-fPIC
make CFLAGS=-fPIC install
cd ../

cd $cur_dir
        wget -c http://imcat.in/down/web/zend/ZendOptimizer-3.3.9-linux-glibc23-x86_64.tar.gz
        tar zxvf ZendOptimizer-3.3.9-linux-glibc23-x86_64.tar.gz
	mkdir -p /usr/local/zend/
	cp ZendOptimizer-3.3.9-linux-glibc23-x86_64/data/5_2_x_comp/ZendOptimizer.so /usr/local/zend/
else
cd $cur_dir
        wget -c http://imcat.in/down/web/zend/ZendOptimizer-3.3.9-linux-glibc23-i386.tar.gz
	tar zxvf ZendOptimizer-3.3.9-linux-glibc23-i386.tar.gz
	mkdir -p /usr/local/zend/
	cp ZendOptimizer-3.3.9-linux-glibc23-i386/data/5_2_x_comp/ZendOptimizer.so /usr/local/zend/
fi

cd $cur_dir
wget -c http://imcat.in/down/web/libiconv/libiconv-1.13.1.tar.gz
tar zxvf libiconv-1.13.1.tar.gz
cd libiconv-1.13.1/
./configure --prefix=/usr/local
make
make install
cd ../

cd $cur_dir
wget -c http://imcat.in/down/web/google-perftools/google-perftools-1.6.tar.gz
tar zxvf  google-perftools-1.6.tar.gz
cd google-perftools-1.6/
./configure
make && make install
echo "/usr/local/lib" > /etc/ld.so.conf.d/usr_local_lib.conf
/sbin/ldconfig
cd ../

cd $cur_dir
wget -c http://imcat.in/down/web/libmcrypt/libmcrypt-2.5.8.tar.gz
tar zxvf libmcrypt-2.5.8.tar.gz
cd libmcrypt-2.5.8/
./configure
make
make install
/sbin/ldconfig
cd libltdl/
./configure --enable-ltdl-install
make
make install
cd ../../

cd $cur_dir
wget -c http://imcat.in/down/web/mhash/mhash-0.9.9.9.tar.gz
tar zxvf mhash-0.9.9.9.tar.gz
cd mhash-0.9.9.9/
./configure
make
make install
cd ../

ln -s /usr/local/lib/libmcrypt.la /usr/lib/libmcrypt.la
ln -s /usr/local/lib/libmcrypt.so /usr/lib/libmcrypt.so
ln -s /usr/local/lib/libmcrypt.so.4 /usr/lib/libmcrypt.so.4
ln -s /usr/local/lib/libmcrypt.so.4.4.8 /usr/lib/libmcrypt.so.4.4.8
ln -s /usr/local/lib/libmhash.a /usr/lib/libmhash.a
ln -s /usr/local/lib/libmhash.la /usr/lib/libmhash.la
ln -s /usr/local/lib/libmhash.so /usr/lib/libmhash.so
ln -s /usr/local/lib/libmhash.so.2 /usr/lib/libmhash.so.2
ln -s /usr/local/lib/libmhash.so.2.0.1 /usr/lib/libmhash.so.2.0.1
ln -s /usr/local/bin/libmcrypt-config /usr/bin/libmcrypt-config

cd $cur_dir
wget -c http://imcat.in/down/web/mcrypt/mcrypt-2.6.8.tar.gz
tar zxvf mcrypt-2.6.8.tar.gz
cd mcrypt-2.6.8/
./configure
make
make install
cd ../

echo "============================mysql install=================================="
cd $cur_dir
wget -c http://imcat.in/down/web/mysql/mysql-5.1.53.tar.gz
tar -zxvf mysql-5.1.53.tar.gz
cd mysql-5.1.53
./configure --prefix=/usr/local/mysql --with-extra-charsets=all --enable-thread-safe-client --enable-assembler --with-charset=utf8 --enable-thread-safe-client --with-extra-charsets=all --with-big-tables --with-readline --with-ssl --with-embedded-server --enable-local-infile --without-debug --with-mysqld-ldflags=-ltcmalloc_minimal
make && make install
cd ../
groupadd mysql
useradd -g mysql mysql
cp /usr/local/mysql/share/mysql/my-medium.cnf /etc/my.cnf
/usr/local/mysql/bin/mysql_install_db --user=mysql
chown -R mysql /usr/local/mysql/var
chgrp -R mysql /usr/local/mysql/.
cp /usr/local/mysql/share/mysql/mysql.server /etc/init.d/mysql
chmod 755 /etc/init.d/mysql
chkconfig --level 345 mysql on
echo "/usr/local/mysql/lib/mysql" >> /etc/ld.so.conf
echo "/usr/local/lib" >>/etc/ld.so.conf
ldconfig
ln -s /usr/local/mysql/lib/mysql /usr/lib/mysql
ln -s /usr/local/mysql/include/mysql /usr/include/mysql
service mysql start
/usr/local/mysql/bin/mysqladmin -u root password $mysqlrootpwd
service mysql restart
service mysql stop
echo "============================mysql intall finished========================="

echo "============================php+eaccelerator install======================"
cd $cur_dir
wget -c http://imcat.in/down/web/php/php-5.2.15.tar.gz
wget -c http://imcat.in/down/web/php-fpm/php-5.2.15-fpm-0.5.14.diff.gz
tar zxvf php-5.2.15.tar.gz
gzip -cd php-5.2.15-fpm-0.5.14.diff.gz | patch -d php-5.2.15 -p1
cd php-5.2.15
./configure --prefix=/usr/local/php --with-config-file-path=/usr/local/php/etc --with-mysql=/usr/local/mysql --with-mysqli=/usr/local/mysql/bin/mysql_config --with-iconv-dir=/usr/local --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml --disable-rpath --enable-discard-path --enable-bcmath --enable-shmop --enable-sysvsem --enable-inline-optimization --enable-fpm --with-curl --with-curlwrappers --enable-mbregex --enable-fastcgi --enable-force-cgi-redirect --enable-mbstring --with-mcrypt --with-gd --enable-gd-native-ttf --with-openssl --with-mhash --enable-pcntl --enable-sockets --with-ldap --with-ldap-sasl --with-xmlrpc --enable-zip --enable-soap --enable-ftp --disable-debug --without-pear --with-gettext --with-mime-magic
make ZEND_EXTRA_LIBS='-liconv'
make install
cp php.ini-dist /usr/local/php/etc/php.ini
ln -s /usr/local/php/bin/php /usr/bin/php
cd ../

cd $cur_dir
wget -c http://imcat.in/down/web/memcache/memcache-2.2.5.tgz
tar zxvf memcache-2.2.5.tgz
cd memcache-2.2.5
/usr/local/php/bin/phpize
./configure --with-php-config=/usr/local/php/bin/php-config
make
make install
cd ../


cd $cur_dir
wget -c http://imcat.in/down/web/pdo_mysql/PDO_MYSQL-1.0.2.tgz
tar zxvf PDO_MYSQL-1.0.2.tgz
cd PDO_MYSQL-1.0.2
/usr/local/php/bin/phpize
./configure --with-php-config=/usr/local/php/bin/php-config --with-pdo-mysql=/usr/local/mysql
make
make install
cd ../

sed -i 's#extension_dir = "./"#extension_dir = "/usr/local/php/lib/php/extensions/no-debug-non-zts-20060613/"\nextension = "memcache.so"\nextension = "pdo_mysql.so"\n#' /usr/local/php/etc/php.ini
sed -i 's#output_buffering = Off#output_buffering = On#' /usr/local/php/etc/php.ini
sed -i 's/post_max_size = 8M/post_max_size = 16M/g' /usr/local/php/etc/php.ini
sed -i 's/upload_max_filesize = 2M/upload_max_filesize = 32M/g' /usr/local/php/etc/php.ini
sed -i 's/;date.timezone =/date.timezone = PRC/g' /usr/local/php/etc/php.ini
sed -i 's/; cgi.fix_pathinfo=0/cgi.fix_pathinfo=0/g' /usr/local/php/etc/php.ini

cat >>/usr/local/php/etc/php.ini<<EOF
[Zend Optimizer] 
zend_optimizer.optimization_level=1023 
zend_extension="/usr/local/zend/ZendOptimizer.so" 
EOF



groupadd www
useradd -g www www
mkdir -p /home/www
chmod +w /home/www
mkdir -p /home/logs
chmod 777 /home/logs

chown -R www:www /home/www
mv /usr/local/php/etc/php-fpm.conf /usr/local/php/etc/php-fpm.conf.bak
cp conf/php-fpm.conf /usr/local/php/etc/php-fpm.conf

echo "============================php+eaccelerator install finished======================"

echo "============================nginx install================================="
cd $cur_dir
wget -c http://imcat.in/down/web/pcre/pcre-8.01.tar.gz
tar zxvf pcre-8.01.tar.gz
cd pcre-8.01/
./configure
make && make install
cd ../

cd $cur_dir
wget -c http://imcat.in/down/web/nginx/nginx-0.8.53.tar.gz
tar zxvf nginx-0.8.53.tar.gz
cd nginx-0.8.53
./configure --user=www --group=www --prefix=/usr/local/nginx --with-http_stub_status_module --with-http_ssl_module --with-http_gzip_static_module --with-ipv6 --with-ld-opt='-ltcmalloc_minimal'
make && make install
cd ../
rm -f /usr/local/nginx/conf/nginx.conf
cp conf/nginx.conf /usr/local/nginx/conf/nginx.conf
sed -i 's/imcat.in/'$domain'/g' /usr/local/nginx/conf/nginx.conf

mkdir -p /usr/local/nginx/conf/sites
mkdir -p /home/www/protected
mkdir -p /home/www/blocked
chown www -R  /home/
chown www /usr/local/nginx/conf/
chown www /usr/local/php/etc/
cp conf/index.php /home/www/php.php
cp conf/index.php /home/www/protected/index.php
cp conf/index.html /home/www/index.html
cp conf/htpasswd /home/htpasswd
cp conf/location.conf /usr/local/nginx/conf/location.conf
cp conf/wordpress.conf /usr/local/nginx/conf/wordpress.conf
cp conf/dabr.conf /usr/local/nginx/conf/dabr.conf
cp conf/discuz.conf /usr/local/nginx/conf/discuz.conf
cp conf/sablog.conf /usr/local/nginx/conf/sablog.conf
cp conf/typecho.conf /usr/local/nginx/conf/typecho.conf
cp conf/supercache.conf /usr/local/nginx/conf/supercache.conf
cp conf/dabr.conf /usr/local/nginx/conf/dabr.conf
cp conf/nginx /etc/init.d/nginx
cp conf/php-fpm /etc/init.d/php-fpm
chmod 777 /etc/init.d/nginx
chmod 777 /etc/init.d/php-fpm
chkconfig --level 345 nginx on
chkconfig --level 345 php-fpm on
service mysql start
/etc/init.d/php-fpm start
/etc/init.d/nginx start
echo "============================nginx install finished================================="

cat >/home/www/phpinfo.php<<eof
<?
phpinfo();
?>
eof
echo "============================phpMyAdmin install================================="

wget -c http://catlnmp.googlecode.com/files/phpMyAdmin-3.3.6-all-languages.tar.gz
tar zxvf phpMyAdmin-3.3.6-all-languages.tar.gz
mv phpMyAdmin-3.3.6-all-languages /home/www/phpmyadmin
echo "============================phpMyAdmin install finished================================="

echo "============================Other settings startup============================"
echo "ulimit -SHn 65535" >>/etc/rc.local
echo "===========================Other settings finished===================="

clear
echo "========================================================================="
echo ""
echo "default mysql root password:yourpassword"
echo "phpinfo test:http://localhost/phpinfo.php"
echo "phpMyAdmin test:http://localhost/phpmyadmin"
echo "The path of some dirs:"
echo "mysql dir:   /usr/local/mysql"
echo "php dir:     /usr/local/php"
echo "nginx dir:   /usr/local/nginx"
echo "web dir      /home/www"
echo ""
echo "========================================================================="
fi
